package cn.com.infosec.crypto.modes;

import cn.com.infosec.crypto.BlockCipher;
import cn.com.infosec.crypto.BufferedBlockCipher;
import cn.com.infosec.crypto.DataLengthException;
import cn.com.infosec.crypto.InvalidCipherTextException;

/** @deprecated */
public class PaddedBlockCipher extends BufferedBlockCipher {
   public PaddedBlockCipher(BlockCipher cipher) {
      super.cipher = cipher;
      super.buf = new byte[cipher.getBlockSize()];
      super.bufOff = 0;
   }

   public int getOutputSize(int len) {
      byte[] var2;
      int var3;
      if ((var3 = (len += super.bufOff) % (var2 = super.buf).length) == 0) {
         return super.forEncryption ? len + var2.length : len;
      } else {
         return len - var3 + var2.length;
      }
   }

   public int getUpdateOutputSize(int len) {
      int var2;
      byte[] var3;
      return (var2 = (len += super.bufOff) % (var3 = super.buf).length) == 0 ? len - var3.length : len - var2;
   }

   public int processByte(byte in, byte[] out, int outOff) {
      int var4 = 0;
      byte[] var5;
      if (super.bufOff == (var5 = super.buf).length) {
         var4 = super.cipher.processBlock(var5, 0, out, outOff);
         super.bufOff = 0;
      }

      byte[] var10001 = super.buf;
      int var6;
      super.bufOff = (var6 = super.bufOff) + 1;
      var10001[var6] = in;
      return var4;
   }

   public int processBytes(byte[] in, int inOff, int len, byte[] out, int outOff) {
      if (len >= 0) {
         int var6 = this.getBlockSize();
         int var7;
         if ((var7 = this.getUpdateOutputSize(len)) > 0 && outOff + var7 > out.length) {
            throw new DataLengthException("output buffer too short");
         } else {
            byte var12 = 0;
            byte[] var8;
            int var9;
            int var10;
            int var10000;
            if (len > (var10 = (var8 = super.buf).length - (var9 = super.bufOff))) {
               var10000 = inOff;
               System.arraycopy(in, inOff, var8, var9, var10);
               inOff = super.cipher.processBlock(super.buf, 0, out, outOff) + var12;
               super.bufOff = 0;
               len -= var10;

               for(var7 = var10000 + var10; len > super.buf.length; var7 += var6) {
                  int var10004 = inOff;
                  inOff += outOff;
                  inOff = var10004 + super.cipher.processBlock(in, var7, out, inOff);
                  len -= var6;
               }
            } else {
               var10000 = inOff;
               inOff = var12;
               var7 = var10000;
            }

            PaddedBlockCipher var10001 = this;
            PaddedBlockCipher var10002 = this;
            PaddedBlockCipher var10005 = this;
            byte[] var11 = super.buf;
            System.arraycopy(in, var7, var11, var10005.bufOff, len);
            var10001.bufOff = var10002.bufOff + len;
            return inOff;
         }
      } else {
         throw new IllegalArgumentException("Can't have a negative input length!");
      }
   }

   public int doFinal(byte[] out, int outOff) {
      int var3 = super.cipher.getBlockSize();
      int var4 = 0;
      int var6;
      if (super.forEncryption) {
         if (super.bufOff == var3) {
            if (outOff + var3 * 2 > out.length) {
               throw new DataLengthException("output buffer too short");
            }

            var4 = super.cipher.processBlock(super.buf, 0, out, outOff);
            super.bufOff = 0;
         }

         for(byte var9 = (byte)(var3 - super.bufOff); (var6 = super.bufOff) < var3; super.bufOff = var6 + 1) {
            super.buf[var6] = var9;
         }

         int var10002 = outOff;
         byte[] outOff1 = super.buf;
         var3 = var10002 + var4;
         int out1 = var4 + super.cipher.processBlock(outOff1, 0, out, var3);
         var3 = out1;
      } else {
         if (super.bufOff != var3) {
            throw new DataLengthException("last block incomplete in decryption");
         }

         byte[] var10003 = super.buf;
         var4 = super.cipher.processBlock(var10003, 0, var10003, 0);
         super.bufOff = 0;
         byte[] var5;
         if ((var6 = (var5 = super.buf)[var3 - 1] & 255) < 0 || var6 > var3) {
            throw new InvalidCipherTextException("pad block corrupted");
         }

         var3 = var4 - var6;
         System.arraycopy(var5, 0, out, outOff, var3);
      }

      this.reset();
      return var3;
   }
}
